﻿unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.WebBrowser, FMX.ScrollBox,
  FMX.Memo, FMX.Edit, IPPeerClient, REST.Client, Data.Bind.Components,
  Data.Bind.ObjectScope, REST.Authenticator.OAuth, REST.Types;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Button2: TButton;
    Edit2: TEdit;
    Button3: TButton;
    ImageControl1: TImageControl;
    RESTClient3: TRESTClient;
    RESTRequest3: TRESTRequest;
    RESTResponse3: TRESTResponse;
    Label1: TLabel;
    RESTRequest1: TRESTRequest;
    RESTClient1: TRESTClient;
    RESTResponse1: TRESTResponse;
    RESTClient2: TRESTClient;
    RESTRequest2: TRESTRequest;
    RESTResponse2: TRESTResponse;
    OAuth2Authenticator1: TOAuth2Authenticator;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Edit3: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure WebBrowser1DidFailLoadWithError(ASender: TObject);
    procedure WebBrowser1DidFinishLoad(ASender: TObject);
    procedure WebBrowser1DidStartLoad(ASender: TObject);
    procedure WebBrowser1ShouldStartLoadWithRequest(ASender: TObject;
      const URL: string);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  // 카카오톡 개발자 사이트에서 앱 등록 후 API키를 등록하세요.
  API_KEY = '0dcd9a0136ee27a3d9e19effc4b66831';

implementation

uses
  System.JSON;

{$R *.fmx}

// 서비스에 대한 인증(카카오 로그인)
procedure TForm1.Button1Click(Sender: TObject);
var
  url: string;
  param: string;
begin
  Edit1.Text := '';

  url := 'https://kauth.kakao.com';
//  param := '/oauth/authorize?client_id={app_key}&redirect_uri={redirect_uri}&response_type=code';
  param := '/oauth/authorize?client_id={app_key}&redirect_uri={redirect_uri}&response_type=code&scope=friends,talk_message';
  param := param.Replace('{app_key}', API_KEY);
  param := param.Replace('{redirect_uri}', 'http://hjf.pe.kr/oauth');

  WebBrowser1.URL := url + param;
  WebBrowser1.Navigate;
end;

// 로그인 성공 시 인증 코드 수신
procedure TForm1.WebBrowser1DidFinishLoad(ASender: TObject);
var
  url: string;
  code: string;
begin
  Memo1.Lines.Add('WebBrowser1DidFinishLoad' + WebBrowser1.URL);

  if Edit1.Text <> '' then
    Exit;

  url := WebBrowser1.URL;

  if Pos('code=', url) > 0 then
  begin
    code := Copy(url, Pos('code=', url) + Length('code='), Length(url));
    if Pos('&', code) > 0 then
      code := Copy(code, 1, Pos('&', code)-1);

    Edit1.Text := code;
  end;

//  WebBrowser1.
end;

// 제대로 인증된 사용자인지 확인 > 엑세스 토큰 발급
procedure TForm1.Button2Click(Sender: TObject);
var
  token: string;
begin
  RESTClient1.BaseURL := 'https://kauth.kakao.com/';

  RESTRequest1.Resource := 'oauth/token';
  RESTRequest1.Method := rmPOST;
  RESTRequest1.Accept := '*/*';
  RESTRequest1.Params.Clear;
  RESTRequest1.Params.AddItem('grant_type',   'authorization_code');
  RESTRequest1.Params.AddItem('client_id',    API_KEY);
  RESTRequest1.Params.AddItem('redirect_uri', 'http://hjf.pe.kr/oauth');
  RESTRequest1.Params.AddItem('code',         Edit1.Text);

  RESTRequest1.Execute;

  Memo1.Lines.Text := RESTResponse1.Content;

  if RESTResponse1.JSONValue.TryGetValue<string>('access_token', token) then
    Edit2.Text := token;
end;

// 엑세스 토큰으로 카카오톡 프로필
procedure TForm1.Button3Click(Sender: TObject);
var
  Url: string;
  Stream: TMemoryStream;
begin
  OAuth2Authenticator1.AccessToken := Edit2.Text;

  RESTClient2.BaseURL := 'https://kapi.kakao.com/';
  RESTClient2.Authenticator := OAuth2Authenticator1;

  RESTRequest2.Client := RESTClient2;
  RESTRequest2.Response := RESTResponse2;

  RESTRequest2.Method := rmGET;
  RESTRequest2.Resource := 'v1/api/talk/profile';
  RESTRequest2.Execute;

  Memo1.Lines.Text := RESTResponse2.Content;

  Url := RESTResponse2.JSONValue.GetValue<string>('profileImageURL');

  RESTClient3.BaseURL := Url;
  RESTClient3.Authenticator := OAuth2Authenticator1;
  RESTRequest3.ExecuteAsync(procedure
    begin
      Stream := TMemoryStream.Create;
      try
        Stream.WriteData(RESTResponse3.RawBytes, RESTResponse3.ContentLength);
        ImageControl1.Bitmap.LoadFromStream(Stream);
      finally
        Stream.Free;
      end;
    end
  );
end;

// 카카오톡 "친구 목록 조회"
procedure TForm1.Button4Click(Sender: TObject);
begin
  OAuth2Authenticator1.AccessToken := Edit2.Text;

  RESTClient2.BaseURL := 'https://kapi.kakao.com/';
  RESTClient2.Authenticator := OAuth2Authenticator1;

  RESTRequest2.Client := RESTClient2;
  RESTRequest2.Response := RESTResponse2;
  RESTRequest2.Method := rmGet;

  RESTRequest2.Resource := 'v1/api/talk/friends';
  RESTRequest2.Execute;

  Memo1.Lines.Text := RESTResponse2.Content;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  Data: string;
  JSON: TJSONObject;
begin
  OAuth2Authenticator1.AccessToken := Edit2.Text;

  RESTClient2.BaseURL := 'https://kapi.kakao.com/';
  RESTClient2.Authenticator := OAuth2Authenticator1;

  RESTRequest2.Client := RESTClient2;
  RESTRequest2.Response := RESTResponse2;
  RESTRequest2.Method := rmPOST;

  RESTRequest2.Resource := 'v2/api/talk/memo/default/send';
  RESTRequest2.Params.Clear;

  JSON := TJSONObject.Create;
  JSON.AddPair('object_type',   'text');
  JSON.AddPair('text',          Edit3.Text);
  JSON.AddPair('link', TJSONObject.Create.AddPair('web_url', '').AddPair('', ''));

//  Data := '{"object_type": "text","text": "텍스트영영", "link":{"web_url":"http://hjf.pe.kr","mobile_web_url":"http://hjf.pe.kr"}, "button_title": "바로 확인"}';
  Data := '{"object_type": "text","text": "텍스트영영", "link":{"web_url":"http://hjf.pe.kr","mobile_web_url":"http://hjf.pe.kr"}, "button_title": "바로 확인"}';
  RESTRequest2.Params.AddItem('template_object',   Data);

  RESTRequest2.Execute;

  Memo1.Lines.Text := RESTResponse2.Content;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  url: string;
  param: string;
begin
  url := 'https://kauth.kakao.com';
  param := '/oauth/authorize?client_id={app_key}&redirect_uri={redirect_uri}&response_type=code&scope=friends,talk_message';
  param := param.Replace('{app_key}', API_KEY);
  param := param.Replace('{redirect_uri}', 'http://hjf.pe.kr/oauth');

  WebBrowser1.URL := url + param;
  WebBrowser1.Navigate;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  Data: string;
  JSONData, JSONLink: TJSONObject;
begin

  JSONData := TJSONObject.Create;
  JSONData.AddPair('object_type',   'text');
  JSONData.AddPair('text',          '텍스트 영역');
  JSONLink := TJSONObject.Create.AddPair('web_url', '').AddPair('mobile_web_url', '');
  JSONData.AddPair('link', JSONLink);

  Data := JSONData.ToJSON;
  JSONData.Free;

  ShowMessage(Data);
end;

procedure TForm1.WebBrowser1DidFailLoadWithError(ASender: TObject);
begin
  Memo1.Lines.Add('WebBrowser1DidFailLoadWithError' + WebBrowser1.URL);
end;

procedure TForm1.WebBrowser1DidStartLoad(ASender: TObject);
begin
  Memo1.Lines.Add('WebBrowser1DidStartLoad' + WebBrowser1.URL);
end;

procedure TForm1.WebBrowser1ShouldStartLoadWithRequest(ASender: TObject;
  const URL: string);
begin
  Memo1.Lines.Add('WebBrowser1ShouldStartLoadWithRequest = ' + URL);
end;

end.
